<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>List Drink</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center text-info">Quản trị Drink</h2>
        <div class="jumbotron">
            <div class="row form-group">
                <label for="ma-nuoc-uong" class="col-sm-3">Mã nước uống</label>
                <div class="col-sm-9">
                    <input id="inp-ma-nuoc-uong" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="ma-nuoc-uong" class="col-sm-3">Tên nước uống</label>
                <div class="col-sm-9">
                    <input id="inp-ten-nuoc-uong" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="ma-nuoc-uong" class="col-sm-3">Đơn giá</label>
                <div class="col-sm-9">
                    <input id="inp-don-gia" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="ma-nuoc-uong" class="col-sm-3">Ghi chú</label>
                <div class="col-sm-9">
                    <input id="inp-ghi-chu" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="ma-nuoc-uong" class="col-sm-3">Ngày tạo</label>
                <div class="col-sm-9">
                    <input id="inp-ngay-tao" type="date" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label  for="ma-nuoc-uong" class="col-sm-3">Ngày cập nhật</label>
                <div class="col-sm-9">
                    <input id="inp-ngay-cap-nhat" type="date" class="form-control">
                </div>
            </div>
            <button id="btn-save" class="btn btn-success">Save Data</button>
            <button id="btn-delete" class="btn btn-danger">Delete</button>


        </div>

        <table id="table-drink" class="table table-bordered table-hover table-stripped">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Mã Nước Uống</th>
                    <th>Tên Nước Uống</th>
                    <th>Đơn giá</th>
                    <th>Ghi chú</th>
                    <th>Ngày tạo</th>
                    <th>Ngày cập nhật</th>
                </tr>
            </thead>
            <tbody>
                
            </tbody>
        </table>
    </div>

    <!-- Modal -->
<div class="modal fade" id="modal-delete" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Delete Voucher</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <h5>Bạn có chắc chắn muốn xóa bỏ loại nước này?</h5>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
          <button id="btn-confirm" type="button" class="btn btn-danger">Xác nhận</button>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
    "use trict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    var gTableDrinks = $("#table-drink").DataTable({
        "columns": [
            {"data" : "id"},
            {"data" : "maNuocUong"},
            {"data" : "tenNuocUong"},
            {"data" : "donGia"},
            {"data" : "ghiChu"},
            {"data" : "ngayTao"},
            {"data" : "ngayCapNhat"}
        ]
    });
    // Biến toàn cục để lưu Id 
    var gDrinkId = null;


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    $("#table-drink").on("click", "tr", function() {
        onClickRowDrink(this);
    });

    $("#btn-save").on("click", function() {
        onBtnSaveDataClick();
    });

    $("#btn-delete").on("click", function() {
        $("#modal-delete").modal("show");
    });

    $("#btn-confirm").on("click", function() {
        onBtnConfirmDeleteClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm sự kiện tải trang
    function onPageLoading() {
        callApiToLoadListDrink();
    }

    // Hàm xử lý sự kiện nhấn vào row trong datatable
    function onClickRowDrink(paramRow) {
        var vDataRow = gTableDrinks.row(paramRow).data();
        gDrinkId = vDataRow.id;
        fillDataRowToForm(vDataRow);
    }


    // Hàm xử lý sự kiện nhấn nút save data
    function onBtnSaveDataClick() {
        // cần kiểm tra dữ liệu 
        var vDrink = {
            maNuocUong: "",
            tenNuocUong: "",
            donGia: 0,
            ghiChu: ""
        }
        getDataToForm(vDrink);
        // validate dữ liệu
        var vValidate = validateDrinkData(vDrink);
        if(vValidate && gDrinkId == null) {
            callApiToCreateDrink(vDrink);
        }
        if(vValidate && gDrinkId != null) {
            callApiToUpdateDrink(vDrink);
        }
    }

    // Hàm xử lý sự kiện nhất nút xác nhận trong modal delete
    function onBtnConfirmDeleteClick() {
        $.ajax({
            type: "DELETE",
            url: "http://localhost:8080/drinks/" + gDrinkId,
            success: function(paramRes) {
                alert("Xóa dữ liệu thành công!");
                callApiToLoadListDrink();
                $("#modal-delete").modal("hide");
            },
            error: function(paramError) {
                alert("Xóa dữ liệu thất bại, vui lòng thử lại!");
                console.log(paramError.status);
            }
        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi api để lấy danh sách toàn bộ nước uống
    function callApiToLoadListDrink() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/drinks/",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToTable(paramRes);
            }, 
            error: function(paramError) {
                console.log(paramError.status);
            }

        })
    }

    // Hàm load dữ liệu trả về vào bảng
    function loadDataToTable(paramData) {
        gTableDrinks.clear();
        gTableDrinks.rows.add(paramData);
        gTableDrinks.draw();
    }

    // Hàm load dữ liệu row vào form
    function fillDataRowToForm(paramDataRow) {
        $("#inp-ma-nuoc-uong").val(paramDataRow.maNuocUong);
        $("#inp-ten-nuoc-uong").val(paramDataRow.tenNuocUong);
        $("#inp-don-gia").val(paramDataRow.donGia);
        $("#inp-ghi-chu").val(paramDataRow.ghiChu);
        var ngayTao = changeDateFormat(paramDataRow.ngayTao);
        $("#inp-ngay-tao").val(ngayTao);
        if(paramDataRow.ngayCapNhat != null) {
            var ngayCapNhat = changeDateFormat(paramDataRow.ngayCapNhat);
            $("#inp-ngay-cap-nhat").val(ngayCapNhat);
        }
    }

    // Hàm định dạng lại ngày tháng theo kiểu date để có thể điền vào input-ngay-tao và ngay cập nhật
    // Dùng hàm split để chia ra thành 3 thông qua - sau đó sắp xếp lại vị trí
    function changeDateFormat(paramDate) {
        let dateParts = paramDate.split("-");
        let formattedDate = dateParts[2] + '-' + dateParts[1] + '-' + dateParts[0];
        return formattedDate;
    }

    // Hàm get giá trị từ form
    function getDataToForm(paramDrink) {
        paramDrink.maNuocUong = $("#inp-ma-nuoc-uong").val();
        paramDrink.tenNuocUong = $("#inp-ten-nuoc-uong").val();
        paramDrink.donGia = $("#inp-don-gia").val();
        paramDrink.ghiChu = $("#inp-ghi-chu").val();
    }

    // Hàm validate dữ liệu
    function validateDrinkData(paramDrink) {
        if(paramDrink.maNuocUong == "") {
            alert("Mã nước uống không được để trống!");
            return false;
        }
        
        if(paramDrink.tenNuocUong == "") {
            alert("Tên nước uống không được để trống!");
            return false;
        }

        if(paramDrink.donGia < 10000) {
            alert("Giá tiền phải lớn hơn 10000!");
            return false;
        }
        return true;
    }

    // Hàm gọi api để tạo mới 1 loại nước
    function callApiToCreateDrink(paramDrinkData) {
        $.ajax({
            type: "POST",
            url: "http://localhost:8080/drinks/",
            contentType: "application/json",
            data: JSON.stringify(paramDrinkData),
            success: function(paramRes) {
                handleOnCreateDrinkSuccess(paramRes);
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Tạo mới thất bại vui lòng thử lại!");
            }
        });
    }

    // Hàm xử lý khi tạo mới thành công
    function handleOnCreateDrinkSuccess() {
        alert("Tạo mới thành công!");
        callApiToLoadListDrink();
    }

    // Hàm gọi API để update loại nước 
    function callApiToUpdateDrink(paramDrinkData) {
        $.ajax({
            type: "PUT",
            url: "http://localhost:8080/drinks/" + gDrinkId,
            contentType: "application/json",
            data: JSON.stringify(paramDrinkData),
            success: function(paramRes) {
                handleOnUpdateDrinkSuccess(paramRes);
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Cập nhật thất bại, vui lòng thử lại!")
            }
        });
    }

    // Hàm xử lý sau khi sửa thành công
    function handleOnUpdateDrinkSuccess() {
        alert("Cập nhật thành công!");
        callApiToLoadListDrink();
    }
    
</script>
</html>